

( function( $ ) {
    "use strict";
    $( window ).on( 'elementor/frontend/init', function() {
          var EF = elementorFrontend,
              EM = elementorModules;
  
          var ExtensionHandler = EM.frontend.handlers.Base.extend({
              onInit: function() {
                  EM.frontend.handlers.Base.prototype.onInit.apply(this, arguments);
                  this.init();
              },
              getConfig: function(key) {
                  return this.getElementSettings(key);
              },
              init: function() {
                var scope = this.$element,
                    font_size = this.getConfig('font_size') || 60,
                    font_family = this.getConfig('font_family') || 'Impact, Charcoal, sans-serif',
                    font_color = this.getConfig('font_color') || '#000',
                    font_bg_color = this.getConfig('font_bg_color') || '',
                    outline_size = this.getConfig('outline_size') || 1,
                    outline_color = this.getConfig('outline_color') || '#fff',
                    shape_color = this.getConfig('shape_color') || '#fff',
                    line_size = this.getConfig('line_size') || 10,
                    line_color = this.getConfig('line_color') || '#F44336',
                    Wfont_family = this.getConfig('w_font_family') || 'Georgia, serif',
                    Wfont_size = this.getConfig('w_font_size') || 22,
                    Wfont_weight = this.getConfig('w_font_weight') || 'bold',
                    Wfont_style = this.getConfig('w_font_style') || 'italic',
                    Wfont_color = this.getConfig('w_font_color') || '#fff',
                    Wfont_bg_color = this.getConfig('w_font_bg_color') || '#000',
                    Wtext_align = this.getConfig('w_text_align') || 'right';
      
                // Tmcaps plugin init
                scope.find('.tm-caps-container').tmcaps({
                    fontFamily: font_family,
                    fontSize: parseInt(font_size),
                    fill: font_color,
                    stroke: outline_color,
                    strokeWidth: parseInt(outline_size),
                    textBackgroundColor: font_bg_color,
                    shapeColor: shape_color,
                    lineColor: line_color,
                    lineWidth: parseInt(line_size),
                    WfontSize: parseInt(Wfont_size),
                    WfontFamily: Wfont_family,
                    WfontWeight: Wfont_weight,
                    WfontStyle: Wfont_style,
                    Wfill: Wfont_color,
                    WtextBackgroundColor: Wfont_bg_color,
                    WtextAlign: Wtext_align,
                    enableRetinaScaling: (this.getConfig('retina') === 'true')
                });

                // Tooltip init
                scope.find('.tm-caps-tooltip').tooltipster({
                    animation: 'fade',
                    animationDuration: 200,
                    onlyOne: true,
                    position:'top',
                    speed:200,
                    theme: 'tmcaps',
                    touchDevices:false
                });

                // Live search
                function filterResults(e){
                    scope.find('.tm-caps-gallery-item').hide().filter('[data-search-term*="'+ e +'"]').show();
                }

                scope.find('.tmcaps-live-search-box').on('keyup input', function () {
                    scope.find(".tmcaps-no-results-message").hide();
                    var searchTerm = jQuery(this).val().toLowerCase().replace(/\s/g,'');
                    if ((searchTerm == '') || (searchTerm.length < 1)) {
                        scope.find('.tm-caps-gallery-item').show();
                        scope.find('.tmcaps-live-search-container i').removeClass('fa-times');
                        scope.find('.tmcaps-live-search-container i').addClass('fa-search');
                    } else {
                        scope.find('.tmcaps-live-search-container i').removeClass('fa-search');
                        scope.find('.tmcaps-live-search-container i').addClass('fa-times');
                        filterResults(searchTerm);
                        if (scope.find(".tm-caps-gallery-item:visible").length === 0) {
                            scope.find(".tmcaps-no-results-message").show();
                        }
                    }
                });

                scope.find('.tmcaps-live-search-container > i').on('click', function () {
                    if ($(this).hasClass('fa-times')) {
                        $(this).removeClass('fa-times');
                        $(this).addClass('fa-search');
                        scope.find('.tmcaps-live-search-box').val('');
                        scope.find('.tm-caps-gallery-item').show();
                        scope.find(".tmcaps-no-results-message").hide();
                    }
                });
                       
                   
              }
          });
          EF.hooks.addAction( 'frontend/element_ready/tmcaps-meme-generator.default', function( $scope ) {
              EF.elementsHandler.addHandler( ExtensionHandler, { $element: $scope });
          });
          });
  } )( jQuery );
  